#ifndef lint
static char ID_cardfile[] = "@(#)cardfile.h	3.3   DeltaDate 11/25/01    ExtrDate 12/10/01";
#endif

/*	CARDFILE.h	*/
#include	"string.h"

#define SWIDTH	(size_t)80	/* width of screen line */
#define	SLENGTH	24	/* length of screen */
#define PWIDTH	(size_t)80	/* width of printer line */
#define	MSGLINE	(SLENGTH-2) /* screen message line */
#define DBSIZE	(size_t)1024	/* max size of record in DB file */
#define AKSIZE	270	/* max size of record in AK file */
#define MAXFLDS	15	/* max number of fields in record */
#define FNSIZE	128	/* max size of a file name */
#define PLENGTH	66	/* number of lines per page on printer */
#define MAXAK	15	/* max number of AK files */
#define FLDLEN	256	/* max length of one field */
#define TSIZE	20	/* max length of field title */
#define BUFSIZE	(2*1024) /* size of buffer used to build AK files */
#define MAXKEYS	500	/* maximium keys on one find screen */
#define	MAXFMT	128	/* maximum length of a format string */
#ifndef TRUE
# define TRUE	1
# define FALSE	0
#endif

typedef long	diskptr;

struct Sdata	{	/* structure to describe a screen field */
    char	*S_title;
    int		S_length;
    char	*S_result;
    char	*S_dfault;
    int		S_page;
    int		S_Lrow;
    int		S_Lcol;
    int		S_Drow;
    int		S_Dcol;
    char	*S_Dfmt;
};

struct Fdata	{	/* structure to define a data-base field */
    char	F_title[TSIZE+1];
    char	F_required;
    int		F_length;
    char	F_key;
    char	F_seps[6];
    char	F_page;		/* What screen page this field will appear on */
    int		F_Lrow;		/* The screen field label row address */
    int		F_Lcol;		/* The screen field label column address */
    int		F_Drow;		/* The screen field data row address */
    int		F_Dcol;		/* The screen field data column address */
    char	F_Dfmt[MAXFMT+1];	/* The screen field data format (fmt_chk) */
};

struct AKdata	{	/* structure to hold Alternate Key file info */
    int		A_fldnum;
    char	A_akname[FNSIZE+1];
};

struct	cchar {		/* strings received from terminal */
    char	ch;
    int		(*action)();
    struct	cchar *next;
    struct	cchar *alt;
};

struct	SFdata {
		int	f_page;
		int	f_tline;
		int	f_tcol;
		char	*f_title;
		int	f_dline;
		int	f_dcol;
		char	*f_dfmt;
		int	f_length;
		char	*f_result;
		char	*f_dfault;
	};

extern char	datadir[];
extern int	Dlvl;
SIGRTN		getout();
void		exit(), free();
unsigned	sleep();
/*char		*tparm();*/


extern int screen(char *first, struct Sdata *vardata, char *last, int *left, int ro, int no_intr);
extern int add(struct Fdata fields[], char *dbname);
extern int change(struct Fdata fields[], char *dbname);
extern int db_define(char *basename);
extern int delete(struct Fdata fields[], char *dbname);
extern int extract(struct Fdata *fields, char *dbname);
extern int findrcds(struct Fdata *fields, char *dbname, int (*display)(), char *first);
extern int find(struct Fdata *fields, char *dbname);
extern int menu(char *dbname, char **functs);
extern int printdb(struct Fdata *fields, char *dbname);
extern int buildak(char *dbname, char *recd, long addr, struct Fdata *fp, char *buffer);
extern int writeak(char *dbname, char *buffer);
extern int compress(char *dbname);
extern int dumpdb(char *dbname, struct AKdata *ak_data, struct Fdata *fields);
extern int rbuildak(char *dbname, struct AKdata *ak_data, struct Fdata *fields);
extern int putrcd(char *first, char *rcd, FILE *file, char *fmt, int width, int space);
extern int keymatch(char *akrcd, char *val);
extern void setupkeys(void);
extern int fmt_chk(char *field, char *fmt);
extern int goright(struct SFdata field_tbl[]);
extern int goleft(struct SFdata field_tbl[]);
extern int ferase(struct Sdata *dummy);
extern int delchar(struct Sdata *dummy);
extern void resetcursor(void);
extern void maint(struct Fdata *fields, char *dbname, struct AKdata *ak_data);
extern void msg(char *str);
extern void help(char *help_msg);
extern int rawgetchar(int no_intr);
extern void rawputchar(char ch);
extern int echo(void);
extern int noecho(void);
extern diskptr getkey(FILE *file, char *val);
extern int nextpage(struct SFdata field_tbl[]);
extern int prevpage(struct SFdata field_tbl[]);
extern int nextfield(struct SFdata dummy[]);
extern int prevfield(struct SFdata dummy[]);
