#ifndef lint
static char Sccsid[] = "@(#)getfld.c	1.3    DeltaDate 11/25/01    ExtrDate 12/10/01";
#endif

/*      GETFLD.C        */
/*
 *	This subroutine is used to extract a field from a string
 *	of the form :
 *		field0:field1:field2:field3:...:fieldN\0
 *	It returns a pointer to a static area into which the field
 *	has been copied with a null ('\0') appended, or NULL if the
 *	field number is greater than the number of fields on the line.
 *	The field separator character can be any character that does
 *	not appear in the string.
 */

#include <stdio.h>
#include "cardfile.h"


char *
pgetfld(line, fnum, sep)
char	*line;
int	fnum;
char	sep;
{
	static	char field[FLDLEN+1];
	int	o;

	while (fnum > 0) {
		while (*line != sep && *line != '\0')
			line++;
		if (*line == '\0') {
			fnum = -1;
		} else {
			++line;
			--fnum;
		}
	}
	if (fnum < 0)
		return(NULL);
	o = 0;
	while (*line != sep && *line != '\0' && o < FLDLEN) {
		field[o++] = *(line++);
	}
	field[o] = '\0';
	return(field);
}

/*
 *	Shortcut if the separator is a colon, ':'
 */
char *
getfld(line, field)
char	*line;
int	field;
{
    return(pgetfld(line, field, ':'));
}



/*
 *	Return a pointer to the start of the field in the input
 *	string.  This avoids the problem of the maximum string length
 *	in the allocation of the static return value in pgetfld above.
 *	It is the callers responsibility to find the end of the field.
 */
char *
pgetfldp(line, fnum, sep)
char	*line;
int	fnum;
char	sep;
{

	while (fnum > 0) {
		while (*line != sep && *line != '\0')
			line++;
		if (*line == '\0') {
			fnum = -1;
		} else {
			++line;
			--fnum;
		}
	}
	if (fnum < 0)
		return(NULL);
	return(line);
}

/*
 *	Shortcut if the separator is a colon
 */
char *
getfldp(line, fnum)
char	*line;
int	fnum;
{
    return(pgetfldp(line, fnum, ':'));
}

